# Algoritmos Comunes en JavaScript

[![Build Status](https://travis-ci.org/sumtype/common-algorithms-js.svg?branch=master)](https://travis-ci.org/sumtype/common-algorithms-js) [![Coverage Status](https://coveralls.io/repos/github/sumtype/common-algorithms-js/badge.svg?branch=master)](https://coveralls.io/github/sumtype/common-algorithms-js?branch=master) [![Known Vulnerabilities](https://snyk.io/test/github/sumtype/common-algorithms-js/badge.svg)](https://snyk.io/test/github/sumtype/common-algorithms-js) [![JavaScript Style Guide](https://img.shields.io/badge/code_style-standard-brightgreen.svg)](https://standardjs.com) [![npm](https://img.shields.io/npm/dt/common-algorithms-js.svg)](https://www.npmjs.com/package/common-algorithms-js)

Comúnmente algoritmos implementados en JavaScript con [Mocha](https://mochajs.org/)/[Chai](http://chaijs.com/) de ensayo utilizado.

### Colección

* [Selección Ordenar](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/selectionSort.js)
* [Ordenamiento de Burbuja](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/bubbleSort.js)
* [Ordenamiento de Cóctel](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/cocktailSort.js)
* [Búsqueda Lineal](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/linearSearch.js)
* [Combinar Ordenar](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/mergeSort.js)
* [Ordenación Rápida](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/quickSort.js)
* [Búsqueda Binaria](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/binarySearch.js)
* [Ordenamiento por Inserción](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/insertionSort.js)
* [Clasificación del Cucharón](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/bucketSort.js)
* [Clasificación de Shell](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/shellSort.js)
* [Contar Ordenar](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/countingSort.js)
* [Ordenar Gnomo](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/gnomeSort.js)
* [Clase de Radix](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/radixSort.js)
* [Ordenar Dormir](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/sleepSort.js)
* [Durstenfeld Barajar (a.k.a. Knuth Barajar)](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/durstenfeldShuffle.js)
* [Sattolo Ciclo](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/sattoloCycle.js)
* [Depósito Muestreo](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/reservoirSampling.js)

### Cuerda

* [Son Anagramas](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/areAnagrams.js)
* [Son Palíndromos](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/arePalindromes.js)
* [Combinación de Cuerdas de Fuerza Bruta](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/bruteForceStringMatch.js)
* [Más Largo Subcadena Común](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/longestCommonSubstring.js)
* [Más Larga Subsecuencia Común](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/longestCommonSubsequence.js)
* [Levenshtein Distancia](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/levenshteinDistance.js)
* [Damerau-Levenshtein Distancia](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/damerauLevenshteinDistance.js)
* [Sørensen-Dice Coeficiente](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/sorensenDiceCoefficient.js)
* [Knuth-Morris-Pratt Cadena Igualar](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/knuthMorrisPrattStringMatch.js)
* [Rabin-Karp Cadena Igualar](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/rabinKarpStringMatch.js)
* [Boyer-Moore Cadena Igualar](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/boyerMooreStringMatch.js)
* [Boyer-Moore-Horspool Cadena Igualar](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/boyerMooreHorspoolStringMatch.js)
* [Hamming Distancia](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/hammingDistance.js)
* [Delimitadores a Juego](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/matchingDelimiters.js)
* [Tiene Caracteres Duplicados](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/hasDuplicateCharacters.js)

### Grafico

* [Profundidad Primera Búsqueda](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/depthFirstSearch.js)
* [Amplitud Primera Búsqueda](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/breadthFirstSearch.js)

### Geometría

* [Ray-Casting](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/rayCasting.js)
* [Bezier Curva](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/bezierCurve.js)

### Mates

* [Fibonacci Número](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/fibonacciNumber.js)
* [Es Primo](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/isPrime.js)
* [Tamiz de Atkin](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/sieveOfAtkin.js)
* [Tamiz de Eratosthenes](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/sieveOfEratosthenes.js)
* [Factores Primo](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/primeFactors.js)
* [Set de Poder](https://github.com/sumtype/common-algorithms-js/blob/master/algorithms/es/powerSet.js)

## Pruebas

Para ejecutar las pruebas usted mismo necesitará descargar el proyecto e instalar sus dependencias de módulo de nodo a través de [npm](https://www.npmjs.com/). Por lo tanto, si aún no ha instalado [Node.js](https://nodejs.org/) y npm para usarlo en su línea de comandos, vaya al sitio web de Node.js y siga sus instrucciones de descarga e instalación. Una vez instalado Node.js y npm, clone el proyecto en su computadora usando el siguiente comando en el terminal/el símbolo del sistema/la consola:

`git clone https://github.com/sumtype/common-algorithms-js.git`

(Solo en caso de que no haya instalado [Git](https://git-scm.com/), siga las instrucciones de instalación [aquí](https://git-scm.com/book/en/v2/Getting-Started-Installing-Git), luego vuelva a introducir el comando anterior una vez instalado). descargado el proyecto utilice el siguiente comando para navegar al directorio raíz del proyecto:

`cd common-algorithms-js`

A continuación, instale las dependencias del módulo de nodo del proyecto desde npm. Para ello, ingrese este comando:

`npm install`

Una vez instaladas todas las dependencias, estarás listo para ejecutar las pruebas. Escriba el siguiente comando para ejecutarlos:

`npm run local-test`

Este repositorio usa [Travis-CI](https://travis-ci.org/sumtype/common-algorithms-js) para las pruebas de despliegue en las versiones 8.9.x y 9.4.x de Node.js.
